<?php
/*
Simple:Press Plugin Title: Who's Online
Version: 1.2.4
Plugin URI: http://simple-press.com
Description: A Simple:Press plugin for showing who is online around your forum
Author: Andy Staines & Steve Klasen
Author URI: http://simple-press.com
Simple:Press Versions: 5.2 and above
$LastChangedDate: 2013-08-23 12:55:44 -0700 (Fri, 23 Aug 2013) $
$Rev: 10569 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# IMPORTANT DB VERSION
define('SPWODBVERSION', 1);

define('SPWODIR', 			SFPLUGINDIR.'online/');
define('SPWOADMINDIR', 		SFPLUGINDIR.'online/admin/');
define('SPWOLIBDIR', 		SFPLUGINDIR.'online/library/');
define('SPWOTEMPDIR', 		SFPLUGINDIR.'online/template-files/');
define('SPWOTAGSDIR', 		SFPLUGINDIR.'online/template-tags/');
define('SPWOCSS', 		    SFPLUGINURL.'online/resources/css/');

add_action('init', 											'sp_online_localization');
add_action('sph_activate_online/sp-online-plugin.php', 		'sp_online_install');
add_action('sph_uninstall_online/sp-online-plugin.php', 	'sp_online_uninstall');
add_action('sph_deactivate_online/sp-online-plugin.php', 	'sp_online_deactivate');
add_action('sph_activated', 				                'sp_online_sp_activate');
add_action('sph_deactivated', 				                'sp_online_sp_deactivate');
add_action('sph_uninstalled', 								'sp_online_sp_uninstall');
add_action('sph_plugin_update_online/sp-online-plugin.php', 'sp_online_upgrade_check');
add_action('admin_footer',                                  'sp_online_upgrade_check');
add_action('sph_get_query_vars', 							'sp_online_get_query_vars');
add_action('sph_get_def_query_vars', 						'sp_online_get_def_query_vars');
add_action('sph_permissions_reset', 						'sp_online_reset_permissions');

add_filter('sph_plugins_active_buttons', 		'sp_online_uninstall_option', 10, 2);
add_filter('sph_rewrite_rules_start', 			'sp_online_rewrite_rules', 10, 3);
add_filter('sph_query_vars', 					'sp_online_query_vars');
add_filter('sph_pageview', 						'sp_online_pageview');
add_filter('sph_canonical_url', 				'sp_online_canonical_url');
add_filter('sph_page_title', 					'sp_online_page_title', 10, 2);
add_filter('sph_DefaultViewTemplate',			'sp_online_template_name', 10, 2);
add_action('sph_print_plugin_styles',			'sp_online_header');
add_filter('sph_perms_tooltips', 				'sp_online_tooltips', 10, 2);
add_filter('sph_BreadCrumbs', 				    'sp_online_breadcrumb', 10, 5);
add_filter('sph_BreadCrumbsMobile', 		    'sp_online_breadcrumbMobile', 10, 2);

function sp_online_localization() {
	sp_plugin_localisation('spwo');
}

function sp_online_install() {
    include_once(SPWODIR.'sp-online-install.php');
    sp_online_do_install();
}

function sp_online_reset_permissions() {
    include_once(SPWODIR.'sp-online-install.php');
    sp_online_do_reset_permissions();
}

function sp_online_uninstall() {
    include_once(SPWODIR.'sp-online-uninstall.php');
    sp_online_do_uninstall();
}

function sp_online_deactivate() {
    sp_deactivate_auth('view_online_activity');
}

function sp_online_sp_activate() {
	include_once(SPWODIR.'sp-online-install.php');
    sp_online_do_sp_activate();
}

function sp_online_sp_deactivate() {
	include_once(SPWODIR.'sp-online-uninstall.php');
    sp_online_do_sp_deactivate();
}

function sp_online_upgrade_check() {
    include_once(SPWODIR.'sp-online-upgrade.php');
    sp_online_do_upgrade_check();
}

function sp_online_sp_uninstall() {
	include_once(SPWODIR.'sp-online-uninstall.php');
    sp_online_do_sp_uninstall();
}

function sp_online_uninstall_option($actionlink, $plugin) {
    include_once(SPWODIR.'sp-online-uninstall.php');
    $actionlink = sp_online_uninstall_option_links($actionlink, $plugin);
	return $actionlink;
}

function sp_online_tooltips($tips, $t) {
    $tips['view_online_activity'] = $t.__('Can view the online activity page showing what users/guests are viewing', 'spwo');
    return $tips;
}

function sp_online_rewrite_rules($rules, $slugmatch, $slug) {
	$rules[$slugmatch.'/online/?$'] = 'index.php?pagename='.$slug.'&sf_online=view';
    return $rules;
}

function sp_online_header() {
    include_once(SPWOLIBDIR.'sp-online-components.php');
    sp_online_do_header();
}

function sp_online_query_vars($vars) {
	$vars[] = 'sf_online';
    return $vars;
}

function sp_online_get_query_vars() {
    global $spVars;
	$spVars['online'] = sp_esc_str(get_query_var('sf_online'));
	if (empty($spVars['online'])) $spVars['online'] = 0;
}

function sp_online_get_def_query_vars($stuff) {
    global $spVars;
    if ($stuff[1] == 'online') {
        $spVars['online'] = true;
        $spVars['plugin-vars'] = true;
    }
	if (empty($spVars['online'])) $spVars['online'] = 0;
}

function sp_online_pageview($pageview) {
    global $spVars;
    if (!empty($spVars['online'])) $pageview = 'online';
    return $pageview;
}

function sp_online_canonical_url($url) {
    include_once(SPWOLIBDIR.'sp-online-components.php');
    $url = spOnlineCanonicalUrl($url);
    return $url;
}

function sp_online_breadcrumb($breadCrumbs, $args, $crumbEnd, $crumbSpace, $treeCount) {
    global $spVars;
    if (!empty($spVars['online'])) {
    	extract($args, EXTR_SKIP);
    	if (!empty($icon)) $icon = "<img src='".SPTHEMEICONSURL.sanitize_file_name($icon)."' class='$iconClass' alt=''/>";
		$breadCrumbs.= $crumbEnd.str_repeat($crumbSpace, $treeCount)."<a class='$linkClass' href='".sp_url('online')."'>".$icon.__('Online', 'spwo').'</a>';
    }
    return $breadCrumbs;
}

function sp_online_breadcrumbMobile($breadCrumbs, $args) {
    global $spVars;
    if (!empty($spVars['online'])) {
    	extract($args, EXTR_SKIP);
		$breadCrumbs.= "<a class='$tagClass' href='".sp_url('online')."'>".$icon.__('Online', 'spwo').'</a>';
    }
    return $breadCrumbs;
}

function sp_online_page_title($title, $sep) {
    include_once(SPWOLIBDIR.'sp-online-components.php');
    $title = spOnlinePageTitle($title, $sep);
    return $title;
}

function sp_online_template_name($name, $pageview) {
    include_once(SPWOLIBDIR.'sp-online-components.php');
    $name = spOnlineTemplateName($name, $pageview);
    return $name;
}

# Define Template Tags globally available (dont have to be enabled on template tag panel)
function sp_OnlineCurrentlyOnline($args, $currentLabel='', $guestLabel='') {
    include_once(SPWOTAGSDIR.'sp-online-currently-tag.php');
    sp_OnlineCurrentlyOnlineTag($args, $currentLabel, $guestLabel);
}

function sp_OnlineSiteActivity($args) {
    include_once(SPWOTAGSDIR.'sp-online-activity-tag.php');
    sp_OnlineSiteActivityTag($args);
}

function sp_OnlinePageLink($args, $label='') {
    include_once(SPWOTAGSDIR.'sp-online-link-tag.php');
    sp_OnlinePageLinkTag($args, $label);
}
?>